/*
** Copyright (C) 2003-2007 Teus Benschop.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 3 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#ifndef INCLUDED_ABIWORD_2_USFM_H
#define INCLUDED_ABIWORD_2_USFM_H


#include "libraries.h"
#include <glib.h>
#include "style.h"
#include <libxml/xmlreader.h>


class Abiword2Usfm
{
public:
  Abiword2Usfm (const vector<ustring>& lines, vector<Style> * styles);
  ~Abiword2Usfm ();
  vector<ustring> output;
  bool success;
private:
  vector<Style> * mystyles;
  ustring outputline;
  vector<ustring> current_styles;
  bool in_footnote_element;
  ustring footnoteline;
  int in_paragraph_or_character_element;
  bool in_non_relevant_element;
  void start_element_handler (xmlTextReaderPtr reader);
  void end_element_handler (xmlTextReaderPtr reader);
  void text_handler (xmlTextReaderPtr reader);
  ustring current_style ();
  void style_get_properties (const ustring& marker, bool& start_newline, bool& newline_on_end, bool& showmarker, bool& plaintext, bool& has_endmarker);
  bool silently_skip_element (const xmlChar *element_name);
  void categorize_element (xmlTextReaderPtr reader, bool start);
};


#endif
