/*
** Copyright (C) 2003-2007 Teus Benschop.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 3 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#ifndef INCLUDED_ABIWORD_UTILS_H
#define INCLUDED_ABIWORD_UTILS_H


#include "libraries.h"
#include "style.h"


enum AbiwordStyleType {
  abwstParagraph, abwstCharacter, abwstVerse, abwstFootnote, abwstEndnote
};


void abiword_style_get_properties (StyleType type, int subtype,
                                   AbiwordStyleType& abiwordstyletype, bool& plaintext, bool& showmarker);
ustring abiword_style_produce_name (const ustring& marker);
void abiword_style_add_property (bool& first_property_added, ustring& line, gchar * property, const ustring& value, gchar * suffix);
ustring abiword_unknown_style ();


#endif
