/*
** Copyright (C) 2003-2007 Teus Benschop.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 3 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#ifndef INCLUDED_DIALOGRESOURCECONVERTER_H
#define INCLUDED_DIALOGRESOURCECONVERTER_H


#include <gtk/gtk.h>
#include "ustring.h"


class ResourceConverterDialog
{
public:
  ResourceConverterDialog (int dummy);
  ~ResourceConverterDialog ();
  int run ();
protected:
  GtkWidget *resourceconverterdialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *label1;
  GtkWidget *hseparator1;
  GtkWidget *hbox3;
  GtkWidget *image_open_ok;
  GtkWidget *label_open_ok;
  GtkWidget *label_open_action;
  GtkWidget *button_open;
  GtkWidget *alignment1;
  GtkWidget *hbox2;
  GtkWidget *image1;
  GtkWidget *label3;
  GtkWidget *label_open_filename;
  GtkWidget *hseparator2;
  GtkWidget *label2;
  GtkWidget *radiobutton_signature_book_space_chapter_colon_verse_line_start;
  GtkWidget *radiobutton_signature_book_and_chapter_on_a_line_verses_follow;
  GtkWidget *hseparator3;
  GtkWidget *hbox4;
  GtkWidget *image_examine_ok;
  GtkWidget *label_examine_ok;
  GtkWidget *label_examine_action;
  GtkWidget *button_examine;
  GtkWidget *alignment2;
  GtkWidget *hbox5;
  GtkWidget *image5;
  GtkWidget *label9;
  GtkWidget *label_examine_results;
  GtkWidget *hseparator4;
  GtkWidget *hbox6;
  GtkWidget *image_review_ok;
  GtkWidget *label_review_ok;
  GtkWidget *label_review_action;
  GtkWidget *button_review;
  GtkWidget *alignment3;
  GtkWidget *hbox7;
  GtkWidget *image7;
  GtkWidget *label13;
  GtkWidget *label_review_result;
  GtkWidget *hseparator5;
  GtkWidget *hbox8;
  GtkWidget *image_write_ok;
  GtkWidget *label_write_ok;
  GtkWidget *label_write_action;
  GtkWidget *button_write;
  GtkWidget *alignment4;
  GtkWidget *hbox9;
  GtkWidget *image9;
  GtkWidget *label17;
  GtkWidget *label_write_result;
  GtkWidget *dialog_action_area1;
  GtkWidget *cancelbutton;
  GtkWidget *okbutton;
private:
  ustring filename;
  vector <ustring> lines;
  vector <unsigned int> anchors_books;
  vector <unsigned int> anchors_chapters;
  vector <unsigned int> anchors_verses;
  vector <unsigned int> anchors_positions;
  unsigned int currentbook, currentchapter;
  bool examined;
  bool reviewed;
  bool written;
  static void on_button_open_clicked (GtkButton *button, gpointer user_data);
  void on_openbutton ();
  static void on_button_examine_clicked (GtkButton *button, gpointer user_data);
  void on_examinebutton ();
  static void on_button_review_clicked (GtkButton *button, gpointer user_data);
  void on_reviewbutton ();
  static void on_button_write_clicked (GtkButton *button, gpointer user_data);
  void on_writebutton ();
  static void on_okbutton_clicked (GtkButton *button, gpointer user_data);
  void on_okbutton ();
  void gui ();
  void examine_book_space_chapter_colon_verse_line_start (unsigned int linenumber, const ustring& line);
  void examine_book_and_chapter_on_a_line_verses_follow (unsigned int linenumber, const ustring& line);
  void insert_anchor (ustring& line, const ustring& anchor);
};


#endif
