/*
** Copyright (C) 2003-2007 Teus Benschop.
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 3 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**  
*/


#ifndef INCLUDED_TABLE_H
#define INCLUDED_TABLE_H


#include "libraries.h"
#include "usfm.h"


class TableCell
{
public:
  TableCell (const ustring& marker_in, const ustring& text_in);
  ustring marker;
  ustring text;
};


class TableRow
{
public:
  TableRow (int dummy);
  vector <TableCell> cells;
};


class XslFoTable
{
public:
  XslFoTable (Usfm * usfm, vector <ustring> * xslfolines);
  ~XslFoTable ();
  void buffer (const ustring& marker, const ustring& text);
  bool pending ();
  void process ();
private:
  Usfm * myusfm;
  vector <ustring> * myxslfolines;
  vector <ustring> buffered_markers;
  vector <ustring> buffered_texts;
};


#endif
